/*
R8C/M12A obe[[d

ZNV̐ݒROM̐擪AhX 0x8000 ɂ邱
FDTŏ݂sƂɂ R5F2LA86A (ROM32KB) w肷邱

2011N1130 \ł悤ɂȂ
2011N1201 `^OAL[s[gǉB^C}[RC PWMo͓BADRo[^
2011N1203 dAďvZǉBj[\ȁH
2011N1206 dρAdǍD
2011N1209 dAd̕ςƂĕ\ TIMERI[o[t[LED_łȂȂ̂C
2011N1210 ADϊ^C~OύXiRyA}b`ARyA}b`Bj
*/

#include "sfr_r8m12a.h"
#include "uart.h"
#include "wait.h"
#include "clcd.h"
#include "trc_pwm.h"
#include "ad.h"

void main(void);
void putvolt(unsigned char a);
void putamp(unsigned char a);

void putvolt(unsigned char a)
{
	cputch(tochar(a/100));
	a=a%100;
	cputch(tochar(a/10));
	cputch('.');
	a=a%10;
	cputch(tochar(a));
	cputch('V');
}

void putamp(unsigned char a)
{
	cputch(tochar(a/10));
	cputch('.');
	a=a%10;
	cputch(tochar(a));
	cputch('A');
}

void setpulse(unsigned short a)
{
	if(a<trcgra) trcgrd=a;
}

unsigned char checkpulse(unsigned short a)
{
	return (a<trcgra);
}

unsigned short getpulse(void)
{
	return trcgrd;
}

void main(void)
{
	unsigned char volt,amp,lvolt,lamp;
	unsigned short pulse,lpulse;
	unsigned char pos;
	unsigned short ledtimer;
	unsigned char STATUS;
	unsigned char V[5],A[5],l;
#define EDIT			(1<<0)
#define RECOVERY		(1<<1)
#define RECOVERY_START	(1<<2)

	// I/O|[gvAbv
	pur1=0b11001000;
	pur3=0b00001000;
	pur4=0b00100000;
	
	p1=0;
	p3=0;
	p4=0;
	
	// I/O|[g 0: 1:o
	pd1=0b10011100;
	pd3=0b10111000;
	pd4=0b11100100;

	osc_init();
	uart_init();
	CLCD_INIT();
	trc_init();
	ad_init();
	
	volt=138;
	amp=8;
	pulse=10;
	STATUS=0;
	setvolt(volt);
	setamp(amp);
	setpulse(0);
	
	asm("LDIPL #0");	// vZbT荞ݗD惌x0i̒lx̊荞݂󂯕tj
	EI();	// 荞݋

	/*
	clocate(0,0);
	cputs("NOW 00.0V 0.00A ");	1sڂ͏Ɍ݂̓dƓd\
	clocate(0,1);
	cputs("SET[00.0V]0.00A ");	2sڂ͐ݒl\BdAd
	cputs("RECOVERY ON[OFF]");	obe񕜋@\ON/OFF
	cputs("PULSE     [1000]");	TtF[VpX
	㉺{^ōڈړ {^ŕҏW[hBlpJ[\\
	ҏW {^:mAE{^:LZ
	ł㉺{^ŏ\ɖ߂
	{^zu    E
	*/
	pos=0;
	l=0;
	while(1)
	{
		unsigned char key;
		
		// \pdƓd̕
		V[l]=getvolt();
		A[l]=getamp();
		if(l>2) l=0; else l++;
		V[4]=((unsigned short)V[0]+V[1]+V[2]+V[3]+V[4])/5;
		A[4]=((unsigned short)A[0]+A[1]+A[2]+A[3]+A[4])/5;
		
		// \
		// 1sڌݒl\

		if((STATUS&EDIT)==0)cdisp(0b00000100);	// ҏWȂJ[\\Ȃ
		else cdisp(0b00000101);	// ҏWlpJ[\\

		clocate(0,0);
		cputs("NOW ");
		if(V[4]>6) putvolt(V[4]);
		else cputs("--.-V");
		cputs("  ");
		if(A[4]>6) putamp(A[4]);
		else cputs("-.-A");
		cputch(' ');

		// 2sڕ\
		ccll(1);	// 2sڃNA J[\s
		switch(pos)
		{
			case 0:
				cputs("SET[");
				putvolt(volt);
				cputs("] ");
				//clocate(10,1);
				putamp(amp);
				clocate(8,1);
				break;
				
			case 1:
				cputs("SET ");
				putvolt(volt);
				cputs(" [");
				putamp(amp);
				cputch(']');
				clocate(14,1);
				break;
				
			case 2:
				if((STATUS & RECOVERY)==0)
				{
					cputs("RECOVERY ON[OFF]");
					clocate(15,1);
				}
				else
				{
					cputs("RECOVERY[ON]OFF");
					clocate(11,1);
				}	
				break;

			case 3:
				cputs("PULSE    [");
				cputd16(pulse);
				cputch(']');
				clocate(15,1);
				break;
				
			case 4:
				cputd16(VOLT);
				cputch(' ');
				cputd16(TARGETVOLT);
				break;

			case 5:
				cputd16(AMP);
				cputch(' ');
				cputd16(LIMITAMP);
				break;
		}

		// ҏW
		key=keyin(100);
		if((STATUS & EDIT)==0)
		{
			// ҏWȂ
			switch(key)
			{
				case KEY_UP:	// 
					if(pos<5) pos++;
					break;
					
				case KEY_DOWN:	// 
					if(pos!=0) pos--;
					break;
					
				case KEY_LEFT:	// 
					lvolt=volt;
					lamp=amp;
					lpulse=pulse;
					STATUS|=EDIT;	// ҏW[hɂ
					break;
					
				case KEY_RIGHT:	// E
					break;
					
				case KEY_UP&KEY_DOWN:	// ㉺
					pos=0;			// \
					break;
			}
		}
		else
		{
			// ҏW
			switch(pos)
			{
				case 0:	// d
					switch(key)
					{
						case KEY_UP:
							if(volt<200) volt++;
							break;
						case KEY_DOWN:
							if(volt>0) volt--;
							break;
						case KEY_LEFT:
							setvolt(volt);
							STATUS&=~EDIT;
							break;
						case KEY_RIGHT:
							volt=lvolt;
							STATUS&=~EDIT;
							break;
						case KEY_UP&KEY_DOWN:
							volt=lvolt;
							STATUS&=~EDIT;	// ㉺ŕҏW[h
							pos=0;
							break;
					}
					break;
				
				case 1:	// d
					switch(key)
					{
						case KEY_UP:
							if(amp<20) amp++;
							break;
						case KEY_DOWN:
							if(amp>7) amp--;
							break;
						case KEY_LEFT:
							setamp(amp);
							STATUS&=~EDIT;
							break;
						case KEY_RIGHT:
							amp=lamp;
							STATUS&=~EDIT;
							break;
						case KEY_UP&KEY_DOWN:
							amp=lamp;
							STATUS&=~EDIT;
							pos=0;
							break;
					}
					break;
				
				case 2:	// Jo[[h ON/OFF
					switch(key)
					{
						case KEY_UP:
						case KEY_DOWN:
							STATUS^=RECOVERY;	// RECOVERYrbg] (^:XOR)
							break;
						case KEY_LEFT:
							if((STATUS&RECOVERY)==0) STATUS&=~RECOVERY_START;
							else STATUS|=RECOVERY_START;
							STATUS&=~EDIT;
							break;
						case KEY_RIGHT:
							if((STATUS&RECOVERY_START)==0) STATUS&=~RECOVERY;
							else STATUS|=RECOVERY;
							STATUS&=~EDIT;
							break;
						case KEY_UP&KEY_DOWN:
							if((STATUS&RECOVERY_START)==0) STATUS&=~RECOVERY;
							else STATUS|=RECOVERY;
							STATUS&=~EDIT;
							pos=0;
							break;
					}
					break;

				case 3:	// Jo[[h̃pX
					switch(key)
					{
						case KEY_UP:
							if(pulse<100) pulse++;
							break;
						case KEY_DOWN:
							if(pulse>0) pulse--;
							break;
						case KEY_LEFT:
							STATUS&=~EDIT;
							break;
						case KEY_RIGHT:
							pulse=lpulse;
							STATUS&=~EDIT;
							break;
						case KEY_UP&KEY_DOWN:
							pulse=lpulse;
							STATUS&=~EDIT;
							pos=0;
							break;
					}
					break;
			}
		}
		
		if((STATUS&RECOVERY_START)==0)
		{
			setpulse(0);
			LED=1;	// Jo[[hȂ LED_
			ledtimer=0;
		}
		else
		{
			if(checkpulse(pulse)) setpulse(pulse);
			
			// Jo[[h̎ LED_
			if((ledtimer<TIMER)|(ledtimer>(TIMER+100)))
			{
				ledtimer=TIMER+100;	// 1b
				LED=~LED;
			}
		}
	}
/*	
	while(1)
	{
		unsigned char a;
		a=keyin(25);
		clocate(9,0);
		if((a&0b0001)==0)cputch('0'); else cputch('1');
		if((a&0b0010)==0)cputch('0'); else cputch('1');
		if((a&0b0100)==0)cputch('0'); else cputch('1');
		if((a&0b1000)==0)cputch('0'); else cputch('1');

		if(a==0b1110) temp++;
		if(a==0b1101) temp--;
		clocate(0,1);
		cputd16(temp);
		
		trcgrc=temp;
		trcgrd=temp;
		
		cputch(' ');
		putvolt(getvolt());
		cputch(' ');
		putamp(getamp());
		
		clocate(0,0);
		cputd8(ad0>>2);
		cputch(' ');
		cputd8(ad1>>2);
		
	}
	
	clocate(0,1);
	while(1)
	{
		unsigned char a;
		a=getch();
		if(a==0x0D)
		{
			cscroll(1);	// sR[hȂXN[
		}
		else
		{
			cputch(a);
		}
	}
*/
}
